
// Fullscreen
GG.fullscreen();

// Initialize Mouse Manager
Mouse mouse;
vec3 mousePos;
spork ~ mouse.start(0);  // start listening for mouse events
spork ~ mouse.selfUpdate();

// Scene setup ===================
15 => float crad;
5 => float cheight;
20 => float cdensity;
8 => float cdist;
2 => float gamespeed;
GG.scene().backgroundColor(@(.85,.8,.95));
GG.camera().pos( @(cdist+crad,0,0) );
GG.camera().lookAt( @(0,0,0) );
0 => float ss; // speed camera movement

// Create game canvas
GCanv canvas --> GG.scene();
@(.9,.7,.8) => vec3 canvasColor;
@(1,1,1) => vec3 canvasScale;
@(0,0,0) => vec3 canvasPos;
canvas.set(cheight,cdensity,crad);
canvas.color(canvasColor);
canvas.pos(canvasPos);
canvas.sca(canvasScale);
GPlane over --> GG.scene();

90 => int numObstacles;
GObs obstacles[numObstacles];
GPlay player --> GG.scene();
player.init(mouse,cheight/2);
player.pos(canvas.getPos(0));
// player.sca(0.7);

for(int i; i<numObstacles; i++)
{
    obstacles[i] @=> GObs obs;
    obs --> canvas;
    obs.init(mouse,@(.1,.1,.1));
    obs.pos(canvas.getPos(i+1));
    obs.posY(Math.random2f(-cheight/2,cheight/2));
    // obs.rot(canvas.getRot(i+1));
    obs.lookAt(@(0,0,0));
    // obstacles[i].pos(@(i/6.5-0.38,0,0.01));
    // obstacles[i].scaWorld(@(1,1,1));
    // obstacles[i].mat().color(@(0,0,0));

}

false => int started;
false => int gameover;

fun void move_camera() {

    if( KB.isKeyDown(KB.KEY_S) ) { // speed up
        if ( ss< 6 ) { ss+5*GG.dt() => ss; }
    } else { 1 => ss; }


    // 3d moving camera to figure out camera position
    if( KB.isKeyDown(KB.KEY_D) ) { // positive x axis
        GG.camera().translate(GG.dt()*ss*GG.camera().right());
    }
    if( KB.isKeyDown(KB.KEY_A) ) { // negative x axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().right());
    }
    if( KB.isKeyDown(KB.KEY_E) ) { // positive y axis
        GG.camera().translate(GG.dt()*ss*GG.camera().forward());
    }
    if( KB.isKeyDown(KB.KEY_Z) ) { // negative y axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().forward());
    }
    if( KB.isKeyDown(KB.KEY_W) ) { // positive z axis
        GG.camera().translate(GG.dt()*ss*GG.camera().up());
    }
    if( KB.isKeyDown(KB.KEY_X) ) { // negative z axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().up());
    }
    if( KB.isKeyDown(KB.KEY_U) ) { // rotate + x axis
        GG.camera().rotateOnWorldAxis(GG.camera().right(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_M) ) { // rotate - x axis
        GG.camera().rotateOnWorldAxis(GG.camera().right(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_I) ) { // rotate + y axis
        GG.camera().rotateOnWorldAxis(GG.camera().forward(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_N) ) { // rotate - y axis
        GG.camera().rotateOnWorldAxis(GG.camera().forward(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_H) ) { // rotate + z axis
        GG.camera().rotateOnWorldAxis(GG.camera().up(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_K) ) { // rotate - z axis
        GG.camera().rotateOnWorldAxis(GG.camera().up(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_P) ) { // print camera pos and angle
        <<< "Position: ", GG.camera().pos() >>>;
        <<< "Rotation: ", GG.camera().rot() >>>;
    }
    if( !started ) {
        if ( KB.isKeyDown(KB.KEY_ENTER) ) {
            true => started;
            // player.play();
            for(int i; i<numObstacles; i++)
            {
                obstacles[i].play();
            }
        }
    }
    if( !gameover ) {
        if( KB.isKeyDown(KB.KEY_UP) ) {
            player.moveUp();
        }
        if( KB.isKeyDown(KB.KEY_DOWN) ) {
            player.moveDown();
        }
    }
    if( gameover ) {
        if ( KB.isKeyDown(KB.KEY_R) ) {
            <<< "Restarting game" >>>;
            false => gameover;
            false => started;
            player.reset();
            canvas.rot(@(0,0,0));
            over.sca(0.01);
        }
    }
}

// Game loop =====================
while(true)
{
    move_camera();

    if( started && !gameover ) {
        canvas.rotate(@(0,-0.1*gamespeed*GG.dt(),0));
        if( player.checkCollision(obstacles) ) {
            <<< "Game Over" >>>;
            true => gameover;

            over.pos(GG.camera().pos());
            over.posX() - 15 => over.posX;
            over.mat().color(@(1,1,1));
            over.sca(8);
            over.rotY(5*Math.pi/12);

            FileTexture tex;
            tex.path(me.dir() + "gameover.jpeg");
            PhongMaterial pmat;
            pmat.diffuseMap( tex );
            over.mat(pmat);
        }
    }

    // Wait for next frame
    GG.nextFrame() => now;
}
