
// Fullscreen
GG.fullscreen();

// TO DO: Decorative
// Have a musical score and Highlight notes that are picked up
// Stars/ moving elements.
// Change hit sound
// Fix win animation
// Win sound, loose sound
// puzzle collect animation
// start/ restart sound

// TO DO: Functional
// Remove score
// Fix different musical elements, how to make it sound cohesive?
// Choose song page
// next level can be melody #2 that plays on top of melody #1

// Initialize Mouse Manager
Mouse mouse;
vec3 mousePos;
spork ~ mouse.start(0);  // start listening for mouse events
spork ~ mouse.selfUpdate();

// Scene setup ===================
40 => int numObstacles;
(numObstacles *15.0)/90.0 => float crad;
5 => float cheight;
20 => float cdensity;
8 => float cdist;
GG.scene().backgroundColor( @(0,0,0) );
GG.camera().pos( @(cdist+crad,0,0) );
GG.camera().lookAt( @(0,0,0) );
0 => float ss; // speed camera movement
// 1 => GG.scene().light().intensity;

// Create game canvas
GCanv canvas --> GG.scene();
@(.2,.1,.15) => vec3 canvasColor;
@(1,1,1) => vec3 canvasScale;
@(0,0,0) => vec3 canvasPos;
canvas.set(cheight,cdensity,crad);
canvas.color(canvasColor);
canvas.pos(canvasPos);
canvas.sca(canvasScale);
GPlane over --> GG.scene();
over.pos(GG.camera().pos());
over.posX() - 15 => over.posX;
over.mat().color(@(1,1,1));
over.sca(.01);
over.rotY(12*Math.pi/25);
FileTexture tex;
tex.path(me.dir() + "gameover.jpeg");
PhongMaterial pmat;
pmat.diffuseMap( tex );
over.mat(pmat);

GPlane wintext --> GG.scene();
wintext.pos(GG.camera().pos());
wintext.posX() - 15 => wintext.posX;
wintext.mat().color(@(1,1,1));
wintext.sca(.01);
wintext.rotY(12*Math.pi/25);
FileTexture tex2;
tex2.path(me.dir() + "youwin.jpg");
PhongMaterial pmat2;
pmat2.diffuseMap( tex2 );
wintext.mat(pmat2);

GPlane instruct --> GG.scene();
FileTexture tex3;
tex3.path(me.dir() + "instruct.png");
PhongMaterial pmat3;
pmat3.diffuseMap( tex3 );
instruct.mat(pmat3);
instruct.pos(GG.camera().pos());
instruct.posX() - 7 => instruct.posX;
instruct.sca(.001);
instruct.rotY(12*Math.pi/25);
instruct.mat().color(@(1,1,1));
instruct.mat().specular(@(1,1,1));

// Setup player
GPlay player --> GG.scene();
player.init(mouse,cheight/2);
player.pos(canvas.getPos(0));
player.color(@(.6,.3,.45));

// Setup obstacles
@(.4,.1,.1) => vec3 obsColor;
@(.4,.2,.3) => vec3 ringColor;
GObs obstacles[numObstacles];

for(int i; i<numObstacles; i++)
{
    obstacles[i] @=> GObs obs;
    obs --> canvas;
    obs.init(mouse,@(.1,.1,.1));
    obs.colorCube(obsColor);
    obs.colorRing(ringColor);
    obs.pos(canvas.getPos(i+1));
    obs.posY(Math.random2f(-cheight/2,cheight/2));
    obs.lookAt(@(0,0,0));
}

// Setup lights

// Setup puzzle pieces
// TO DO: change tones
0 => int numPieces;
// "jinglebells" => string songName;
// player.setScale(Songs.jinglebellStartNote-24,Songs.jinglebellScale);
"hedwigstheme" => string songName;
player.setScale(Songs.hedwigStartNote-24,Songs.hedwigScale);
Songs.songLength(songName) => numPieces;
@(.6,.3,.4) => vec3 puzColor; // or random?
GPuz pieces[numPieces];
int numCollected[numPieces];
GPlane puzCollected[numPieces];
numPieces => int toCollect;

// TO DO: randomize song numbers with pieces
for(int i; i<numPieces; i++)
{
    (numObstacles*1.0)/numPieces => float jump;
    Math.random2f(.5,.7) => puzColor.x;
    Math.random2f(.5,.7) => puzColor.y;
    Math.random2f(.5,.7) => puzColor.z;

    pieces[i] @=> GPuz puz;
    puz --> canvas;
    Songs.songNote(songName, i) @=> float note[];
    puz.init(mouse,note[0],note[1],note[2]);
    puz.color(puzColor);
    puz.pos(canvas.getPos((i+Math.random2f(1,2))*jump));
    puz.posY(Math.random2f(-cheight/2,cheight/2));
    while (player.checkCollision(puz, obstacles))
    {
        puz.posY(Math.random2f(-cheight/2,cheight/2));
    }

    <<< numPieces >>>;
    puzCollected[i] --> GG.scene();
    puzCollected[i].pos( GG.camera().pos() );
    puzCollected[i].posX() - 5 => puzCollected[i].posX;
    puzCollected[i].posY( - 1.8);
    puzCollected[i].posZ( 2.2 - i*0.3);
    puzCollected[i].sca(.2);
    puzCollected[i].rotY(12*Math.pi/25);
    puzCollected[i].mat().color(puzColor+ @(.3,.3,.3));
    puzCollected[i].mat().alpha(0.3);
}

false => int started;
false => int gameover;
false => int coolingR;
false => int won;
5 => int lives;
0 => int score;
2 => float gamespeed;

GSphere temp --> GG.scene();
temp.sca(0.001);
temp.pos( @(0,0,0));
temp.mat().color(@(.6,.2,.4));

// Display ui with info
GText gametext --> GG.scene();
gametext.pos( GG.camera().pos() );
gametext.posX() - 5 => gametext.posX;
gametext.sca(.15);
gametext.text("Lives: " + lives+"\nPieces left: " + toCollect);
gametext.color(@(1,1,1));
gametext.font(me.dir() + "SourceSansPro-Semibold.otf");
gametext.rotY(12*Math.pi/25);
gametext.posY(gametext.posY() - 1.7);
gametext.posZ(gametext.posZ() - 2.5);

GSphere temp1 --> GG.scene();
temp1.sca(0.001);
temp1.pos( @(0,0,0));
temp1.mat().color(@(.6,.2,.4));

// Display ui with info
GText starttext --> GG.scene();
starttext.pos( GG.camera().pos() );
starttext.posX() - 5 => starttext.posX;
starttext.sca(.3);
starttext.text("Click ENTER to start...");
starttext.color(@(.6,.5,.5));
starttext.font(me.dir() + "SourceSansPro-Semibold.otf");
starttext.rotY(12*Math.pi/25);
// starttext.posY(starttext.posY() - 1.8);
// starttext.posZ(starttext.posZ() - 2.5);

GSphere temp2 --> GG.scene();
temp2.sca(0.001);
temp2.pos( @(0,0,0));
temp2.mat().color(@(.6,.2,.4));

Waterfall waterfall --> GG.scene();
waterfall.posY(-3);
waterfall.posZ(5);
waterfall.posX(6);
waterfall.sca(0.2);

// GLight brightball --> GG.scene();
// brightball.pos( player.posWorld() );
// brightball.posX() - 1 => brightball.posX;
// player.player.mat().envMapRefractionRatio(0);

fun void cooldownR() {
    true => coolingR;
    while( KB.isKeyDown(KB.KEY_R) ) {
        50::ms => now;
    }
    false => coolingR;
}

fun void hop(GObs obstacle[]) {
    for(int i; i<numObstacles; i++) {
        spork ~ obstacles[i].hop();
        50::ms => now;
    }
}

fun void move_camera() {

    while(true) {
        if( KB.isKeyDown(KB.KEY_S) ) { // speed up
            waterfall.latest( "S" );
            if ( ss< 30 ) { ss+25*GG.dt() => ss; }
        } else { 5 => ss; }
        if( KB.isKeyDown(KB.KEY_D) ) { // positive x axis
            waterfall.latest( "D" );
            GG.camera().translate(GG.dt()*ss*GG.camera().right());
        }
        if( KB.isKeyDown(KB.KEY_A) ) { // negative x axis
            waterfall.latest( "A" );
            GG.camera().translate(-GG.dt()*ss*GG.camera().right());
        }
        if( KB.isKeyDown(KB.KEY_E) ) { // positive y axis
            waterfall.latest( "E" );
            GG.camera().translate(GG.dt()*ss*GG.camera().forward());
        }
        if( KB.isKeyDown(KB.KEY_Z) ) { // negative y axis
            waterfall.latest( "Z" );
            GG.camera().translate(-GG.dt()*ss*GG.camera().forward());
        }
        if( KB.isKeyDown(KB.KEY_W) ) { // positive z axis
            waterfall.latest( "W" );
            GG.camera().translate(GG.dt()*ss*GG.camera().up());
        }
        if( KB.isKeyDown(KB.KEY_X) ) { // negative z axis
            waterfall.latest( "X" );
            GG.camera().translate(-GG.dt()*ss*GG.camera().up());
        }
        if( KB.isKeyDown(KB.KEY_U) ) { // rotate + x axis
            waterfall.latest( "U" );
            GG.camera().rotateOnWorldAxis(GG.camera().right(), .3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_M) ) { // rotate - x axis
            waterfall.latest( "M" );
            GG.camera().rotateOnWorldAxis(GG.camera().right(), -.3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_I) ) { // rotate + y axis
            waterfall.latest( "I" );
            GG.camera().rotateOnWorldAxis(GG.camera().forward(), .3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_N) ) { // rotate - y axis
            waterfall.latest( "N" );
            GG.camera().rotateOnWorldAxis(GG.camera().forward(), -.3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_H) ) { // rotate + z axis
            waterfall.latest( "H" );
            GG.camera().rotateOnWorldAxis(GG.camera().up(), .3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_K) ) { // rotate - z axis
            waterfall.latest( "K" );
            GG.camera().rotateOnWorldAxis(GG.camera().up(), -.3*GG.dt()*ss);
        }
        if( KB.isKeyDown(KB.KEY_P) ) { // print camera pos and angle
            <<< "Position: ", GG.camera().pos() >>>;
            <<< "Rotation: ", GG.camera().rot() >>>;
        }
        if( !started ) {
            if ( KB.isKeyDown(KB.KEY_ENTER) ) {
                waterfall.latest( "ENTER - start" );
                true => started;
                for(int i; i<numObstacles; i++)
                {
                    obstacles[i].play();
                }
                starttext.sca(.003);
            }
        }
        if( !gameover ) {
            if( started & !coolingR & KB.isKeyDown(KB.KEY_R) ) {
                waterfall.latest( "R - reverse" );
                -gamespeed => gamespeed;
                // hop(obstacles);
                spork ~ cooldownR();
                // make music sound
            }
        }
        if( gameover && !won ) {
            if ( KB.isKeyDown(KB.KEY_R) ) {
                waterfall.latest( "R - restart" );
                <<< "Restarting game" >>>;
                false => gameover;
                false => started;
                false => won;
                player.reset();
                canvas.rot(@(0,0,0));
                over.sca(0.01);
                5 => lives;
                0 => score;
                2 => gamespeed;
                numPieces => toCollect;
                for(int i; i<numPieces; i++)
                {
                    pieces[i].reset();
                    0 => numCollected[i];
                    puzCollected[i].mat().alpha(0.3);
                }
                starttext.sca(.3);
            }
        }
        50::ms => now;
    }
}

// fun void move_player(){
//     while(true) {
//         if(!gameover) {
//             if( KB.isKeyDown(KB.KEY_UP) ) {
//                 player.moveUp();
//             }
//             if( KB.isKeyDown(KB.KEY_DOWN) ) {
//                 player.moveDown();
//             }
//         }
//         GG.nextFrame() => now;
//     }
// }

spork ~ move_camera();
// spork ~ move_player();
// Game loop =====================
while(true)
{
    if( KB.isKeyDown(KB.KEY_C) ) { // print camera pos and angle
        waterfall.latest( "C" );
        instruct.sca(5);
        starttext.sca(0.003);
        while( KB.isKeyDown(KB.KEY_C) ) {
            GG.nextFrame() => now;
        }
        instruct.sca(0.001);
        if(!started)
            starttext.sca(0.3);
    }
    // <<< "In the game loop!" >>>;
    if(!gameover) {
        if( KB.isKeyDown(KB.KEY_UP) ) {
            waterfall.latest( "UP" );
            player.moveUp();
        }
        if( KB.isKeyDown(KB.KEY_DOWN) ) {
            waterfall.latest( "DOWN" );
            player.moveDown();
        }
    
        if( started ) {
            canvas.rotate(@(0,-0.1*gamespeed*GG.dt(),0));
            (1+0.01*GG.dt()) *=> gamespeed;
            // make music speedup
            player.checkCollision(obstacles) => int hit;
            if( hit ) {
                lives-1 => lives;
                player.hitsound();
                // make music sound

                if( !won && lives == 0 ) {
                    <<< "Game Over" >>>;
                    true => gameover;
                    // make music sound
                    
                    over.sca(8); // game over screen
                    
                } else {
                    // bounce off obstacle
                    spork ~ player.squish(gamespeed, obstacles[hit-1]);
                    canvas.reverse(gamespeed);
                    -gamespeed => gamespeed;
                }
            }
            player.checkCollision(pieces) => int piece;
            if( piece ) {
                if( numCollected[piece-1] == 0 ) {
                    // spork ~ player.collectsound();
                    <<< "Puzzle piece collected" >>>;
                    pieces[piece-1].collect();
                    // player.collectPiece(piece);
                    // pieces[piece].play();
                    numCollected[piece-1]++;
                    toCollect-1 => toCollect;
                    puzCollected[piece-1].mat().alpha(1);
                }
            }
            if( !won && toCollect == 0 ) {
                <<< "You win!" >>>;
                spork ~ hop(obstacles);
                
                // make music sound
                
                true => won;

                wintext.sca(8);
            }
        } else {
            // blink start text
            if(starttext.sca().x < 0.3) {
                starttext.sca(starttext.sca().x + .001);
            } else {
                starttext.sca(.2);
            }
            // starttext.mat().transparency(0.5*Math.sin(10*now));
        }
        gametext.text("Lives: " + lives+"\nPieces left: " + toCollect);
    } 

    // Wait for next frame
    GG.nextFrame() => now;
}
