// uncomment to run in fullscreen
GG.fullscreen();

// Initialize Mouse Manager
Mouse mouse;
vec3 mousePos;
spork ~ mouse.start(0);  // start listening for mouse events
spork ~ mouse.selfUpdate();

// Scene setup ===================
GG.scene().backgroundColor(@(.95,.8,.9));
GG.camera().pos( @(0,0,7) );
//GG.camera().rot( @(0,0,0) );
0 => float ss; // speed camera movement

// Create blank canvas
GPlane canvas --> GG.scene();
@(.9,.6,.7) => vec3 canvasColor;
@(13,2,1) => vec3 canvasScale;
@(0,0,0) => vec3 canvasPos;
canvas.color(canvasColor);
canvas.pos(canvasPos);
canvas.sca(canvasScale);

6 => int numMandala;
GMand mandalas[numMandala];

FileTexture tex;
tex.path(me.dir() + "tex1.jpeg");


for(int i; i<numMandala; i++)
{
    mandalas[i] @=> GMand mand;
    mand --> GG.scene();
    mand.init(mouse,canvasColor+@(.1,.1,.1));
    mand.pos(@(2*i-5,0,0.01));
    // mandalas[i].pos(@(i/6.5-0.38,0,0.01));
    // mandalas[i].scaWorld(@(1,1,1));
    // mandalas[i].mat().color(@(0,0,0));

    PhongMaterial pmat;
    pmat.diffuseMap( tex );
    //mandalas[i].mat(pmat);

}

NRev reverb => dac;
2 => int numSounds;
BandedWG s[numMandala];
SinOsc s2[numMandala];

float vol[numMandala];
int track[numMandala];
int notes[numMandala];
int sound[numMandala];

// for each mandala
for(int i; i < numMandala; i++) {
    0.0 => vol[i];
    0 => track[i];
    70 => notes[i];
    0 => sound[i];

    // for numSounds sounds

        0 => s[i].gain; // set gain
        1 => s[i].preset; // for BandedWG
        s[i] => reverb; // connect to output

        0 => s2[i].gain; // set gain
        s2[i] => reverb; // connect to output
}

fun void move_camera() {

    if( KB.isKeyDown(KB.KEY_S) ) { // speed up
        if ( ss< 6 ) { ss+5*GG.dt() => ss; }
    } else { 1 => ss; }


    // 3d moving camera to figure out camera position
    if( KB.isKeyDown(KB.KEY_D) ) { // positive x axis
        GG.camera().translate(GG.dt()*ss*GG.camera().right());
    }
    if( KB.isKeyDown(KB.KEY_A) ) { // negative x axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().right());
    }
    if( KB.isKeyDown(KB.KEY_E) ) { // positive y axis
        GG.camera().translate(GG.dt()*ss*GG.camera().forward());
    }
    if( KB.isKeyDown(KB.KEY_Z) ) { // negative y axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().forward());
    }
    if( KB.isKeyDown(KB.KEY_W) ) { // positive z axis
        GG.camera().translate(GG.dt()*ss*GG.camera().up());
    }
    if( KB.isKeyDown(KB.KEY_X) ) { // negative z axis
        GG.camera().translate(-GG.dt()*ss*GG.camera().up());
    }
    if( KB.isKeyDown(KB.KEY_U) ) { // rotate + x axis
        GG.camera().rotateOnWorldAxis(GG.camera().right(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_M) ) { // rotate - x axis
        GG.camera().rotateOnWorldAxis(GG.camera().right(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_I) ) { // rotate + y axis
        GG.camera().rotateOnWorldAxis(GG.camera().forward(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_N) ) { // rotate - y axis
        GG.camera().rotateOnWorldAxis(GG.camera().forward(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_H) ) { // rotate + z axis
        GG.camera().rotateOnWorldAxis(GG.camera().up(), .3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_K) ) { // rotate - z axis
        GG.camera().rotateOnWorldAxis(GG.camera().up(), -.3*GG.dt()*ss);
    }
    if( KB.isKeyDown(KB.KEY_P) ) { // print camera pos and angle
        <<< "Position: ", GG.camera().pos() >>>;
        <<< "Rotation: ", GG.camera().rot() >>>;
    }
}

fun void do_change(int i)
{
    if( KB.isKeyDown(KB.KEY_UP) ) {
        // increase vol
        if ( vol[i] < 0.5) {
            vol[i] + .01 => vol[i];
        }
    }
    if( KB.isKeyDown(KB.KEY_DOWN) ) {
        // decrease vol
        if (vol[i] > 0) {
            vol[i] - .01 => vol[i];
        }
    }
    if( KB.isKeyDown(KB.KEY_LEFT) ) {
        // change track next
        notes[i] - 1 => notes[i];
    }
    if( KB.isKeyDown(KB.KEY_RIGHT) ) {
        // change track prev
        notes[i] + 1 => notes[i];
    }
    if( KB.isKeyDown(KB.KEY_T) ) {
        // change track prev
        (sound[i] + 1)%numSounds => sound[i];
    }
}


fun void move_audio() {
    while(true) {
//         for(int i; i < numMandala; i_++) {
//             if( KB.isKeyDown(KB.KEY_4) ) { // choose i-th circle
//                 do_change(3);
//                 100::ms => now;
//             }
//         }
        if( KB.isKeyDown(KB.KEY_1) ) { // choose first circle
            do_change(0);
            100::ms => now;
        }
        if( KB.isKeyDown(KB.KEY_2) ) { // choose second circle
            do_change(1);
            100::ms => now;
        }
        if( KB.isKeyDown(KB.KEY_3) ) { // choose third circle
            do_change(2);
            100::ms => now;
        }
        if( KB.isKeyDown(KB.KEY_4) ) { // choose i-th circle
            do_change(3);
            100::ms => now;
        }
        if( KB.isKeyDown(KB.KEY_5) ) { // choose first circle
            do_change(4);
            100::ms => now;
        }
        if( KB.isKeyDown(KB.KEY_6) ) { // choose first circle
            do_change(5);
            100::ms => now;
        }
        10::ms => now;
    }
}

fun void audioLoop()
{
    while(true)
    {
        for(int i; i<numMandala; i++)
        {
            mandalas[i].play();
            200::ms => now;
            mandalas[i].stop();

            // mandalas[i].color( @(notes[i]/100.0,(notes[i]%10)/10.0,vol[i]*2) );
            // 
            // // for each sound in numSounds
            // if (sound[i] == 0) {
            //     vol[i] => s[i].gain;
            //     Std.mtof(notes[i]) => s[i].freq;
            //     40 => s[i].noteOn;
            //     400::ms => now;
            //     40 => s[i].noteOff;
            // }
            //     
            // if (sound[i] == 1) {
            //     vol[i] => s2[i].gain;
            //     Std.mtof(notes[i]) => s2[i].freq;
            //     400::ms => now;
            //     0 => s2[i].gain;
            // }
        }
        
    }
}
spork ~ audioLoop();
spork ~ move_audio();

// infinite time loop
while( true )
{
    move_camera();

    for(int i; i<numMandala; i++)
    {
        mandalas[i].rotateZ(GG.dt());
    }
    
    // IMPORTANT: synchronization point with next frame to render
    GG.nextFrame() => now;
}
