public class Waterfall extends GGen {

    12 => int WATERFALL_DEPTH; // waterfall depth

    // waterfall playhead
    0 => int playhead;
    // lines
    GText wfl[WATERFALL_DEPTH];
    // color
    @(.8, .8, .8) => vec3 color;

    // iterate over line GGens
    for( GText w : wfl )
    {
        // aww yea, connect as a child of this GGen
        w --> this;
        w.text("");
        w.color(color);
        w.font(me.dir() + "SourceSansPro-Semibold.otf");
    }

    // copy
    fun void latest( string s )
    {
        // set into
        s => wfl[playhead].text;
        // advance playhead
        playhead++;
        // wrap it
        WATERFALL_DEPTH %=> playhead;
    }

    // update
    fun void update( float dt )
    {
        // position
        playhead => int pos;
        // for color
        WATERFALL_DEPTH/2.5 => float thresh;
        // depth
        WATERFALL_DEPTH - thresh => float fadeChunk;
        // so good
        for( int i; i < wfl.size(); i++ )
        {
            // start with playhead-1 and go backwards
            pos--; if( pos < 0 ) WATERFALL_DEPTH-1 => pos;
            // offset Z
            // wfl[pos].posZ( -i );
            wfl[pos].posY(i);
            wfl[pos].rot( @(0,1,0) );
            //wfl[pos].posX(-i);
            if( i > thresh )
            {
                wfl[pos].color( ((fadeChunk-(i-thresh))/fadeChunk) * color );
            }
            else
            {
                wfl[pos].color( color );
            }
        }
    }
}